package atomicstryker.battletowers.common;

import java.util.List;

import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLiving;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.DamageSource;
import net.minecraft.util.EnumParticleTypes;
import net.minecraft.util.MathHelper;
import net.minecraft.util.MovingObjectPosition;
import net.minecraft.util.Vec3;
import net.minecraft.world.World;


public class AS_EntityGolemFireball extends Entity
{
	private boolean wasDeflected;
    public EntityLiving shooterEntity;
    public double accelerationX;
    public double accelerationY;
    public double accelerationZ;

    public AS_EntityGolemFireball(World world)
    {
        super(world);
        func_70105_a(0.3F, 0.3F);
		wasDeflected = false;
    }

    @Override
    protected void func_70088_a()
    {
    }
	
    public AS_EntityGolemFireball(World world, EntityLiving entityliving, double diffX, double diffY, double diffZ)
    {
        this(world);
        
        shooterEntity = entityliving;
        field_70159_w = field_70181_x = field_70179_y = 0.0D;
        diffX += field_70146_Z.nextGaussian() * 0.4D;
        diffY += field_70146_Z.nextGaussian() * 0.4D;
        diffZ += field_70146_Z.nextGaussian() * 0.4D;
        double targetDistance = MathHelper.func_76133_a(diffX * diffX + diffY * diffY + diffZ * diffZ);
        accelerationX = (diffX / targetDistance) * 0.1D;
        accelerationY = (diffY / targetDistance) * 0.1D;
        accelerationZ = (diffZ / targetDistance) * 0.1D;
    }

    @SuppressWarnings("rawtypes")
    @Override
    public void func_70071_h_()
    {
        super.func_70071_h_();
        this.func_70015_d(1);
        
        Vec3 curVec = new Vec3(field_70165_t, field_70163_u, field_70161_v);
        Vec3 nextVec = new Vec3(field_70165_t + field_70159_w, field_70163_u + field_70181_x, field_70161_v + field_70179_y);
        MovingObjectPosition collisionPosition = field_70170_p.func_72933_a(curVec, nextVec);
        curVec = new Vec3(field_70165_t, field_70163_u, field_70161_v);
        nextVec = new Vec3(field_70165_t + field_70159_w, field_70163_u + field_70181_x, field_70161_v + field_70179_y);
        if(collisionPosition != null)
        {
            nextVec = new Vec3(collisionPosition.field_72307_f.field_72450_a, collisionPosition.field_72307_f.field_72448_b, collisionPosition.field_72307_f.field_72449_c);
        }
        Entity hitEntity = null;
        List list = field_70170_p.func_72839_b(this, func_174813_aQ().func_72321_a(field_70159_w, field_70181_x, field_70179_y).func_72314_b(1.0D, 1.0D, 1.0D));
        double minDist = 0.0D;
        for (Object aList : list)
        {
            Entity ent = (Entity) aList;
            if (!ent.func_70067_L() || (ent == shooterEntity && field_70173_aa < 25 && !wasDeflected))
            {
                continue;
            }
            AxisAlignedBB axisalignedbb = ent.func_174813_aQ().func_72314_b(0.3F, 0.3F, 0.3F);
            MovingObjectPosition entCollision = axisalignedbb.func_72327_a(curVec, nextVec);
            if (entCollision == null)
            {
                continue;
            }
            double distToCollision = curVec.func_72438_d(entCollision.field_72307_f);
            if (distToCollision < minDist || minDist == 0.0D)
            {
                hitEntity = ent;
                minDist = distToCollision;
            }
        }

        if(hitEntity != null)
        {
            collisionPosition = new MovingObjectPosition(hitEntity);
        }
        if(collisionPosition != null)
        {
            if(!field_70170_p.field_72995_K)
            {
                if(collisionPosition.field_72308_g != null)
                {
                    collisionPosition.field_72308_g.func_70097_a(DamageSource.func_76358_a(shooterEntity), 0);
                }
                field_70170_p.func_72885_a(null, field_70165_t, field_70163_u, field_70161_v, 1.0F, true, true);
            }
            func_70106_y();
        }
        field_70165_t += field_70159_w;
        field_70163_u += field_70181_x;
        field_70161_v += field_70179_y;
        float f = MathHelper.func_76133_a(field_70159_w * field_70159_w + field_70179_y * field_70179_y);
        field_70177_z = (float)((Math.atan2(field_70159_w, field_70179_y) * 180D) / 3.1415927410125732D);
        for(field_70125_A = (float)((Math.atan2(field_70181_x, f) * 180D) / 3.1415927410125732D); field_70125_A - field_70127_C < -180F; field_70127_C -= 360F) { }
        for(; field_70125_A - field_70127_C >= 180F; field_70127_C += 360F) { }
        for(; field_70177_z - field_70126_B < -180F; field_70126_B -= 360F) { }
        for(; field_70177_z - field_70126_B >= 180F; field_70126_B += 360F) { }
        field_70125_A = field_70127_C + (field_70125_A - field_70127_C) * 0.2F;
        field_70177_z = field_70126_B + (field_70177_z - field_70126_B) * 0.2F;
        float f1 = 0.95F;
        if(func_70090_H())
        {
            for(int k = 0; k < 4; k++)
            {
                float f3 = 0.25F;
                field_70170_p.func_175688_a(EnumParticleTypes.WATER_BUBBLE, field_70165_t - field_70159_w * (double)f3, field_70163_u - field_70181_x * (double)f3, field_70161_v - field_70179_y * (double)f3, field_70159_w, field_70181_x, field_70179_y);
            }

            f1 = 0.8F;
        }
        field_70159_w += accelerationX;
        field_70181_x += accelerationY;
        field_70179_y += accelerationZ;
        field_70159_w *= f1;
        field_70181_x *= f1;
        field_70179_y *= f1;
        field_70170_p.func_175688_a(EnumParticleTypes.SMOKE_NORMAL, field_70165_t, field_70163_u + 0.5D, field_70161_v, 0.0D, 0.0D, 0.0D);
        func_70107_b(field_70165_t, field_70163_u, field_70161_v);
    }

    @Override
    public boolean func_70067_L()
    {
        return true;
    }

    @Override
    public float func_70111_Y()
    {
        return 1.0F;
    }

    @Override
    public boolean func_70097_a(DamageSource damage, float i)
    {
        func_70018_K();
        Entity entity = damage.func_76346_g();
        if(entity != null)
        {
            Vec3 vec3d = entity.func_70040_Z();
            if(vec3d != null)
            {
                field_70159_w = vec3d.field_72450_a;
                field_70181_x = vec3d.field_72448_b;
                field_70179_y = vec3d.field_72449_c;
                accelerationX = field_70159_w * 0.1D;
                accelerationY = field_70181_x * 0.1D;
                accelerationZ = field_70179_y * 0.1D;
				
				wasDeflected = true;
            }
            return true;
        }
		else
        {
            return false;
        }
    }

    @Override
    public void func_70037_a(NBTTagCompound nbttagcompound)
    {
    }

    @Override
    public void func_70014_b(NBTTagCompound nbttagcompound)
    {
    }
    
}
